\ double.f

\ This code is Copyright 1998, Peter Csapo. It is has been distributed free
\ of charge, and no claim is made to its accuracy, reliability or performance
\ in any way. 



code d+
; add the 2 32 bit integers on the stack
        call _save_temp_regs
        movpf  THIGH, tempA
        movpf  TLOW, tempB
        call _poptop
        movpf THIGH, tempC
        movpf TLOW, tempD
        call _poptop
        movpf THIGH, XHIGH
        movpf TLOW, XLOW
        call _poptop
        movfp tempD, WREG
        addwf TLOW, F
        movfp tempC, WREG
        addwfc THIGH, F
        movfp tempB, WREG
        addwfc XLOW, F
        movfp tempA, WREG
        addwfc XHIGH, F
        call _pushtop
        movfp XLOW, TLOW
        movfp XHIGH, THIGH
        goto _restore_temp_regs
        ; defer return
endcode

: d-  dnegate d+ ;

: d0= or 0= ;

: d0< nip 0< ;

: d= d- or 0= ;

: dabs dup 0< if dnegate then ;

: du< rot 2dup = if 2drop u< else u> nip nip then ;

: du> 2swap du< ;

: d< rot 2dup = if 2drop u< else > nip nip then ;

: d> 2swap d< ;

32768 constant highbit

: d2*  ( d1 -- d2 ) \ Shift left one.
        swap 
        dup highbit and >R 
        2* swap 2* 
        R> if 1+ then ;
        
: du2/ ( d1 -- d2 ) \ Shift right one.
        dup odd >R 
        u2/ swap u2/
        R> if highbit or then 
        swap ;
        
: ur/  ( ud u -- q )  \ Rounded division.
        dup u2/ >R  \ Save half divisor.
        um/mod swap R> u> if 1+ then ;


